// Sample1.cpp by Kosei Demura 2005-2008
// My web site is http://demura.net
// This program uses the Open Dynamics Engine (ODE) by Russell Smith.
// The ODE web site is http://ode.org/

#include <ode/ode.h>
#include <drawstuff/drawstuff.h>

#ifdef dDOUBLE
#define dsDrawSphere dsDrawSphereD
#endif

dWorldID world;
dBodyID apple;
dReal r = 0.15, m = 1.0, height = 2.0;
dsFunctions fn;

void simLoop(int pause)
{
    static long simtime = 0;
    static long epochs  = 0;
    float color;

    dWorldStep(world, 0.01);

    const dReal *pos = dBodyGetPosition(apple);
    const dReal *R   = dBodyGetRotation(apple);

    color = (float) ((epochs%10)/10.0);

    dsSetColor(color, 0.0, 1.0 - color);
    dsDrawSphereD(pos,R,r);
    printf("%6d apple position z=%f\n",simtime,pos[2]);
    simtime++;
    if (simtime > 1000)
    {
        simtime = 0;
        dBodyDestroy(apple);
        apple = dBodyCreate(world);
        dMass mass;
        dMassSetZero(&mass);
        dMassSetSphereTotal(&mass,m,r);
        dBodySetMass(apple,&mass);
        dBodySetPosition(apple, 0, 0, height);
        epochs++;
    }
}

void setDrawStuff()
{
    fn.version = DS_VERSION;
    fn.step = &simLoop;
    fn.path_to_textures = "../../drawstuff/textures";
}

int main(int argc, char **argv)
{
    setDrawStuff();
    world = dWorldCreate();
    dWorldSetGravity(world, 0, 0, -0.1);
    apple = dBodyCreate(world);

    dMass mass;
    dMassSetZero(&mass);
    dMassSetSphereTotal(&mass,m,r);
    dBodySetMass(apple,&mass);
    dBodySetPosition(apple, 0, 0, height);
    dsSetSphereQuality(3);
    dsSimulationLoop(argc, argv, 640, 480, &fn);

    dWorldDestroy(world);
    return 0;
}
